#ifdef GL_ES
precision highp  float;
#else
#define highp
#define mediump
#define lowp
#endif

attribute vec3 position;
attribute vec2 texcoord;
uniform mat4 mvpMatrix;
varying vec2 texcoordOut;
uniform float widthFactor;

varying vec2 texcoordOffset[8];


void main(void)
{
	float singleStepOffset = widthFactor;
    texcoordOffset[0] = texcoord + vec2(-4.0*singleStepOffset,0.0);
    texcoordOffset[1] = texcoord + vec2(-3.0*singleStepOffset,0.0);
    texcoordOffset[2] = texcoord + vec2(-2.0*singleStepOffset,0.0);
    texcoordOffset[3] = texcoord + vec2(-1.0*singleStepOffset,0.0);
    texcoordOffset[4] = texcoord + vec2(1.0*singleStepOffset,0.0);
    texcoordOffset[5] = texcoord + vec2(2.0*singleStepOffset,0.0);
    texcoordOffset[6] = texcoord + vec2(3.0*singleStepOffset,0.0);
    texcoordOffset[7] = texcoord + vec2(4.0*singleStepOffset,0.0);
    
	texcoordOut = texcoord;
	gl_Position = mvpMatrix * vec4(position, 1.0);
}

