#ifdef GL_ES
precision highp  float;
#else
#define highp
#define mediump
#define lowp
#endif

attribute vec3 position;
attribute vec2 texcoord;
uniform mat4 mvpMatrix;
varying vec2 texcoordOut;
varying vec2 texcoordOffset[8];
uniform float heightFactor;

void main(void)
{
	float singleStepOffset = heightFactor;
    texcoordOffset[0] = texcoord + vec2(0.0,-4.0*singleStepOffset);
    texcoordOffset[1] = texcoord + vec2(0.0,-3.0*singleStepOffset);
    texcoordOffset[2] = texcoord + vec2(0.0,-2.0*singleStepOffset);
    texcoordOffset[3] = texcoord + vec2(0.0,-1.0*singleStepOffset);
    texcoordOffset[4] = texcoord + vec2(0.0,1.0*singleStepOffset);
    texcoordOffset[5] = texcoord + vec2(0.0,2.0*singleStepOffset);
    texcoordOffset[6] = texcoord + vec2(0.0,3.0*singleStepOffset);
    texcoordOffset[7] = texcoord + vec2(0.0,4.0*singleStepOffset);
    
	texcoordOut = texcoord;
	gl_Position = mvpMatrix * vec4(position, 1.0);
}
