#ifdef GL_ES
precision highp  float;
#else
#define highp
#define mediump
#define lowp
#endif

uniform sampler2D inputImageTexture0; //原图
uniform sampler2D inputImageTexture1; //mask图

varying vec2 texcoordOut;
uniform float blendAlpha;
uniform float saturationAlpha;

const highp vec3 W = vec3(0.2125, 0.7154, 0.0721);

void main()
{
    vec4 srcColor = texture2D(inputImageTexture0, texcoordOut);
    
    vec4 maskColor = texture2D(inputImageTexture1, texcoordOut);
    
    float luminance = dot(srcColor.rgb, W);
    
    vec4 grayColor = vec4(vec3(luminance), srcColor.a);
    
    vec3 effectColorTemp = mix(grayColor,srcColor,maskColor.r).rgb;
    
    mediump vec3 intensity=vec3(dot(effectColorTemp,W));
    effectColorTemp = mix(intensity,effectColorTemp,saturationAlpha);
    
    vec4 effectColor = vec4(effectColorTemp,1.0);
    gl_FragColor = vec4(mix(srcColor,effectColor,blendAlpha).rgb,1.0);
}
