precision highp  float;
uniform sampler2D inputImageTexture0; //原图
uniform sampler2D inputImageTexture1; //素材图
uniform sampler2D inputImageTexture2; //screen图
uniform sampler2D inputImageTexture3; //mask

varying vec2 texcoordOut;
varying vec2 texcoordOut2;
uniform float alpha;

vec4 mixmode(sampler2D sample,vec4 topcolor,vec4 bottomcolor)
{
    vec4 res=vec4(0.0,0.0,0.0,1.0);
    vec2 lookup =vec2(topcolor.r, bottomcolor.r);
    res.r = texture2D(sample, lookup).r*bottomcolor.a;
    
    lookup.x = topcolor.g;
    lookup.y =bottomcolor.g;
    res.g = texture2D(sample, lookup).g*bottomcolor.a;
    
    lookup.x = topcolor.b;
    lookup.y = bottomcolor.b;
    res.b= texture2D(sample, lookup).b*bottomcolor.a;
    
    return res;
}

void main()
{
    vec4 top = texture2D(inputImageTexture0, texcoordOut);
    vec4 tempColor = top;
    vec4 bottom = vec4(0.0, 0.0, 0.0, 0.0);
    vec4 mask = vec4(0.0, 0.0, 0.0, 0.0);
    if (texcoordOut2.x <= 1.0 && texcoordOut2.y<=1.0 && texcoordOut2.x>=0.0 && texcoordOut2.y >=0.0) {
        mask = texture2D(inputImageTexture3, texcoordOut);
        bottom = texture2D(inputImageTexture1, texcoordOut2);
        bottom.a = 1.0-mask.r;
    }
    
    vec4 effect = mixmode(inputImageTexture2,top,bottom);
    top = mix(top, effect, effect.r);
    gl_FragColor = mix(tempColor,top,alpha);
}
