precision highp float;
varying highp vec2 texcoordOut;
varying highp vec2 texcoordOut2;
uniform sampler2D inputImageTexture0;
uniform sampler2D inputImageTexture1;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;
uniform float skinRed;
uniform float skinBlue;
uniform float fWidth;
uniform float fHeight;
uniform float sharpen;
uniform float beautyState;

#define Blend_pLitf(base,blend)   (min(1.0,max(0.0,((base)+2.0*(blend)-1.0))))
#define Blend_hLitf(base,blend) ((blend)<=0.5?(blend)*(base)/0.5:1.0-(1.0-(blend))*(1.0-(base))/0.5)

void main(void)
{
    vec2 xy = texcoordOut;
    vec4 oral =texture2D(inputImageTexture0, xy);
    vec4 gauss =texture2D(inputImageTexture1, xy);
    vec4 tempColor = oral;

    vec4 curve = oral;
    curve.r = texture2D(inputImageTexture2,vec2(curve.r,0.5)).b;
    curve.g = texture2D(inputImageTexture2,vec2(curve.g,0.5)).b;
    curve.b = texture2D(inputImageTexture2,vec2(curve.b,0.5)).b;
    if (beautyState>0.5) {
        float G = oral.g;
        float G1 = 1.0 - gauss.g;
        G1 = Blend_pLitf(G, G1);
        float G2=mix(G,G1,0.5);

        G2=Blend_hLitf(G2, G2);
        G2=Blend_hLitf(G2, G2);
        G2=Blend_hLitf(G2, G2);
        vec4 temp=mix(curve,oral,G2);
        float Offset = max(0.0,min(1.0,(oral.r - (skinRed - 0.5))));
        float falpha = 0.0;
        if(Offset < 0.5)
        {
            falpha = Offset*2.0;//254 - (127 - Offset) * 2;
        }
        else
        {
            falpha = 1.0;
        }
        float OffsetJ = max(0.0,min(1.0,(oral.b - skinBlue)));
        falpha = max(falpha - OffsetJ / 2.0,0.0);

        vec4 final = mix(oral,temp,falpha);
        float tx = 1.0/fWidth;float ty = 1.0/fHeight;
        float sum = 0.25*oral.g;
        sum += 0.125*texture2D(inputImageTexture0,xy+vec2(-tx,0.0)).g;
        sum += 0.125*texture2D(inputImageTexture0,xy+vec2(tx,0.0)).g;
        sum += 0.125*texture2D(inputImageTexture0,xy+vec2(0.0,-ty)).g;
        sum += 0.125*texture2D(inputImageTexture0,xy+vec2(0.0,ty)).g;
        sum += 0.0625*texture2D(inputImageTexture0,xy+vec2(tx,ty)).g;
        sum += 0.0625*texture2D(inputImageTexture0,xy+vec2(-tx,-ty)).g;
        sum += 0.0625*texture2D(inputImageTexture0,xy+vec2(-tx,ty)).g;
        sum += 0.0625*texture2D(inputImageTexture0,xy+vec2(tx,-ty)).g;
        float a = 1.0 - sum;
        a = oral.g + 2.0* a - 1.0;
        a = clamp(a, 0.0, 1.0);
        a = mix(a, oral.g, 0.5);
        float flag = step(0.5, a);
        vec4 color = mix((2.0*a*final), (1.0-2.0*(1.0-a)*(1.0-final)), flag);
        final = sharpen*color+(1.0-sharpen)*final;
        //oral.rgb = final.rgb;
        oral.r = texture2D(inputImageTexture3, vec2(final.r,0.5)).r;
        oral.g = texture2D(inputImageTexture3, vec2(final.g,0.5)).g;
        oral.b = texture2D(inputImageTexture3, vec2(final.b,0.5)).b;
        //oral.rgb = 0.3*(tmp.rgb - ret.rgb)+ret.rgb;
    }

    gl_FragColor = oral;
}
