#ifdef GL_ES//for discriminate GLES & GL
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#else
#define highp
#define mediump
#define lowp
#endif

varying highp vec2 texcoordOut;
uniform sampler2D inputImageTexture0;
uniform sampler2D inputImageTexture1;
uniform sampler2D inputImageTexture2;//mt_skin
uniform sampler2D inputImageTexture3;//lookup
uniform sampler2D inputImageTexture4;//lookuporigin
const float skinRed = 127.0/255.0;
const float skinBlue = 140.0/255.0;
const float sharpen = 0.45;
uniform float textureWidth;
uniform float textureHeight;
uniform float skinAlpha;
#define Blend_pLitf(base,blend)   (min(1.0,max(0.0,((base)+2.0*(blend)-1.0))))
#define Blend_hLitf(base,blend) ((blend)<=0.5?(blend)*(base)/0.5:1.0-(1.0-(blend))*(1.0-(base))/0.5)

void main(void)
{
    vec2 xy = texcoordOut;
    vec4 oral =texture2D(inputImageTexture0, xy);
    vec4 gauss =texture2D(inputImageTexture1, xy);
    
    vec4 curve = oral;
    curve.r = texture2D(inputImageTexture2,vec2(curve.r,0.5)).b;
    curve.g = texture2D(inputImageTexture2,vec2(curve.g,0.5)).b;
    curve.b = texture2D(inputImageTexture2,vec2(curve.b,0.5)).b;
    
    float G = oral.g;
    float G1 = 1.0 - gauss.g;
    G1 = Blend_pLitf(G, G1);
    float G2=mix(G,G1,0.5);
    
    G2=Blend_hLitf(G2, G2);
    G2=Blend_hLitf(G2, G2);
    G2=Blend_hLitf(G2, G2);
    G2=Blend_hLitf(G2, G2);
    vec4 temp=mix(curve,oral,G2*skinAlpha);
    float Offset = max(0.0,min(1.0,(oral.r - (skinRed - 0.5))));
    float alpha = 0.0;
    if(Offset < 0.5)
    {
        alpha = Offset*2.0;//254 - (127 - Offset) * 2;
    }
    else
    {
        alpha = 1.0;
    }
    float OffsetJ = max(0.0,min(1.0,(oral.b - skinBlue)));
    alpha = max(alpha - OffsetJ / 2.0,0.0);
    
    vec4 final = mix(oral,temp,alpha);
    float tx = 1.0 / textureWidth;
    float ty = 1.0 / textureHeight;
    float sum = 0.25*oral.g;
    sum += 0.125*texture2D(inputImageTexture0,xy+vec2(-tx,0.0)).g;
    sum += 0.125*texture2D(inputImageTexture0,xy+vec2(tx,0.0)).g;
    sum += 0.125*texture2D(inputImageTexture0,xy+vec2(0.0,-ty)).g;
    sum += 0.125*texture2D(inputImageTexture0,xy+vec2(0.0,ty)).g;
    sum += 0.0625*texture2D(inputImageTexture0,xy+vec2(tx,ty)).g;
    sum += 0.0625*texture2D(inputImageTexture0,xy+vec2(-tx,-ty)).g;
    sum += 0.0625*texture2D(inputImageTexture0,xy+vec2(-tx,ty)).g;
    sum += 0.0625*texture2D(inputImageTexture0,xy+vec2(tx,-ty)).g;
    
    float a = 1.0 - sum;
    a = oral.g + 2.0* a - 1.0;
    a = clamp(a, 0.0, 1.0);
    a = mix(a, oral.g, 0.5);
    float flag = step(0.5, a);
    vec4 color = mix((2.0*a*final), (1.0-2.0*(1.0-a)*(1.0-final)), flag);
    final = sharpen*color+(1.0-sharpen)*final;
    
    vec3 colorOrigin;
    vec3 texel = final.rgb;
    float blueColor = texel.b * 15.0;
    vec2 quad1, quad2, texPos1, texPos2;
    vec4 newColor1, newColor2, newColor1Origin, newColor2Origin;
    
    quad1.y = floor(floor(blueColor) * 0.25);
    quad1.x = floor(blueColor) - (quad1.y * 4.0);
    quad2.y = floor(ceil(blueColor) * 0.25);
    quad2.x = ceil(blueColor) - (quad2.y * 4.0);
    texPos2 = texel.rg * 0.234375 + 0.0078125;
    texPos1 = quad1 * 0.25 + texPos2;
    texPos2 = quad2 * 0.25 + texPos2;
    
    newColor1 = texture2D(inputImageTexture3, texPos1);
    newColor2 = texture2D(inputImageTexture3, texPos2);
    color.rgb = mix(newColor1.rgb, newColor2.rgb, fract(blueColor));
    newColor1Origin = texture2D(inputImageTexture4, texPos1);
    newColor2Origin = texture2D(inputImageTexture4, texPos2);
    colorOrigin = mix(newColor1Origin.rgb, newColor2Origin.rgb, fract(blueColor));
    vec3 colorMid = mix(colorOrigin, color.rgb, skinAlpha);
    gl_FragColor = vec4(mix(final.rgb, colorMid, 0.35), 1.0);
}

